﻿using System.IO;

namespace Illisian.Utils.IO
{
    public abstract class StreamAdaptor
    {
        protected readonly Stream _stream;

        public StreamAdaptor(Stream stream)
        {
            _stream = stream;
        }

        public Stream UnderlyingStream
        {
            get { return _stream; }
        }

        public void Close()
        {
            _stream.Close();
        }
    }
}